import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class FlappyBird here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class FlappyBird extends Actor
{
    double dy = 0;
    double g = .6;
    double BOOST = -9;
    int animateImg = 2;
    private GreenfootImage upWing;
    private GreenfootImage downWing;
    private GreenfootImage strWing;
    long lastAdded = System.currentTimeMillis();
    /**
     * FlappyBird Constructor
     *
     */
    public FlappyBird()
    {
        upWing = new GreenfootImage("flappybird1.png");
        downWing = new GreenfootImage("flappybird3.png");
        strWing = new GreenfootImage("flappybird2.png");
    }

    /**
     * Act - do whatever the FlappyBird wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() {
        if(((FlappyWorld)(getWorld())).isPaused == false)
        {
            //if touching a pipe game over
            if(getOneIntersectingObject(bottomPipe.class) !=null)
            {
                displayGameOver();
            }
            //ends games if its touching object
            if(getOneIntersectingObject(topPipe.class) !=null)
            {
                displayGameOver();
            }
            setLocation(getX(),(int)(getY()+dy));
            long curTime  = System.currentTimeMillis();
            //this if checks if the space key is down and will make the bird move in the negative direction
            if (curTime >= lastAdded + 250)//5000ms = 5s
            {
                if(Greenfoot.isKeyDown("up"))
                {
                    dy = BOOST;
                    Greenfoot.playSound("wing.wav");
                    lastAdded  = curTime;
                }
            }
            rotation();
            //if the bird is bellow canvas then game over
            if(getY()>= getWorld().getHeight()-60||getY()<= 0)
            {
                displayGameOver();
            }
            dy = dy+g;
            animateImg++; 
            animate();
        }
    }

    
    /**
     * Method rotation
     *  rotates flappy bird deppending on speed
     */
    private void rotation()
    {
        if(dy >-5 && dy<5)
        {
            setRotation(0);
        }
        else if(dy >= 5)
        {
            setRotation(20);
        }
        else if(dy<=-5)
        {
            setRotation(-20);
        }
    }

    /**
     * Method animate
     *  changes flappybird to change what picture he is 
     */
    private void animate()
    {
        if(animateImg % 3 == 0)
        {
            setImage(upWing);
        }
        else if(animateImg % 2 == 0)
        {
            setImage(strWing);
        }
        else
        {
            setImage(downWing);
        }   
    }
    
    /**
     * Method displayGameOver
     * shows the game over as well as playing the hit and sad song
     */
    private void displayGameOver()
    {
        GameOver gameOver = new GameOver();
        getWorld().addObject(gameOver,getWorld().getWidth()/2, getWorld().getHeight()/2);
        Greenfoot.playSound("hit.wav");
        Greenfoot.playSound("sad.mp3");
        Greenfoot.stop();
    }
    
}
    

