import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class FlappyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class FlappyWorld extends World
{
    public boolean isPaused = true;
    int flappyCounter = 0;
    int gap = 400;
    int score = 0;
    int FIRST_PIPE = 233;
    FlappyBirdTitle title = new FlappyBirdTitle();
    Start starty = new Start();
    int pipeCounter= 0;
    int GROUND = 100;
    Score scoreObj = null;
    /**
     * Constructor for objects of class FlappyWorld.
     * 
     */
    public FlappyWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1, false); 
        setPaintOrder(FlappyBirdTitle.class, Start.class, Score.class, GameOver.class,Ground.class, bottomPipe.class, topPipe.class, FlappyBird.class );
        //FlappyBird Title 

        addObject(title, getWidth()/2,getHeight()/7);
        //Title creation

        addObject(starty, getWidth()/2, getHeight()-getHeight()/4);
        //bird creation
        FlappyBird flappy = new FlappyBird();
        addObject(flappy, 100, getHeight()/2);
        //score creation 
        scoreObj = new Score();
        scoreObj.setScore(0);

        Ground groundy = new Ground();
        addObject(groundy, getWidth()/2, getHeight()-25);
        //adds score to the world 
        addObject(scoreObj, getWidth()/2,getHeight()*1/6);
        Greenfoot.start();

    }

    /**
     * Method start
     * allows the game to start after start button clicked
     */
    public void start()
    {
        if (Greenfoot.mouseClicked(starty))
        {
            isPaused = false;
        } 
    }

    /**
     * Method act
     * makes the game to start and creates pipes if they games is paused
     */
    public void act()
    {
        startGame();
        if(isPaused == false)
        {
            pipeMake();
        }
    }

    /**
     * Method pipeMake
     * makes the pipes aswell as makes the sound if he crosses the pipe
     */
    private void pipeMake(){      
        pipeCounter++;
        //make pipes into method
        if(pipeCounter%100==0)
        {
            createPipes();
        }
        //keeps track of score 
        if(pipeCounter >= FIRST_PIPE)
        {   
            if(flappyCounter %100 == 0)
            {
                score++;
                Greenfoot.playSound("point.wav");
                scoreObj.setScore(score);
            }
            flappyCounter++;

        }
    }

    /**
     * Method createPipes
     *  adds the pipe objects to the world
     */
    public void createPipes()
    {
        bottomPipe pippy = new bottomPipe();
        GreenfootImage image = pippy.getImage();

        topPipe piper = new topPipe();
        GreenfootImage img = piper.getImage();

        int y = getRandomNumber(getHeight()/2+image.getHeight()*1/3, getHeight()/2+image.getHeight());
        addObject(pippy, getWidth(), y-30);
        addObject(piper, getWidth(), y-gap);
    }

    /**
     * Method startGame
     * Starts the game if the start button is clicked
     */
    private void startGame()
    {
        if(Greenfoot.mouseClicked(starty)== true)
        {
            removeObject(title);
            removeObject(starty);
            isPaused = false;
        }
    }

    /**
     * Method getRandomNumber
     *
     * @param start A parameter that is the starting number of the sequence 
     * @param end A parameter that is the last number of the sequence 
     * @return The return value that sends the random 
     */
    public int getRandomNumber(int start,int end)
    {
        int normal = Greenfoot.getRandomNumber(end-start+1);
        return normal+start;
    }
}
